#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libpq-fe.h"

#include "config.h"

int main()
{
	PGconn *conn;
	PGresult *res,*res1;
	char *query;
	int i,j;


	conn=PQsetdbLogin(DBHOST,NULL,NULL,NULL,DBNAME,DBUSER,DBPASS);
	query=(char *) malloc(300);
	res=PQexec(conn,"select distinct name from chains");
	for (i=0;i<PQntuples(res);i++)
	{
		printf("%s -N %s\n",IPCHAINS,PQgetvalue(res,i,0));
	};

	res=PQexec(conn,"select name,srcip,srcport,dstip,dstport,iface,proto,prio from chains where direction='input'  order by prio");

	for (i=0;i<PQntuples(res);i++)
	{
		snprintf(query,290,"%s -A input -j %s -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res,i,1),PQgetvalue(res,i,3));


		if (strlen(PQgetvalue(res,i,2))>0)
		{
			strcat(query," --source-port ");
			strcat(query,PQgetvalue(res,i,2));
		}

		if (strlen(PQgetvalue(res,i,4))>1)
		{
			strcat(query," --destination-port ");
			strcat(query,PQgetvalue(res,i,4));
		}

		if (strlen(PQgetvalue(res,i,6))>0)
		{
			strcat(query," --protocol ");
			strcat(query,PQgetvalue(res,i,6));
		}
		if (strlen(PQgetvalue(res,i,5))>0)
		{
			strcat(query," --interface ");
			strcat(query,PQgetvalue(res,i,5));
		}

		printf("%s\n",query);
	}

	res=PQexec(conn,"select name,srcip,srcport,dstip,dstport,iface,proto,prio from chains where direction='output'  order by prio");

	for (i=0;i<PQntuples(res);i++)
	{
		snprintf(query,290,"%s -A output -j %s -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res,i,1),PQgetvalue(res,i,3));


		if (strlen(PQgetvalue(res,i,2))>0)
		{
			strcat(query," --source-port ");
			strcat(query,PQgetvalue(res,i,2));
		}

		if (strlen(PQgetvalue(res,i,4))>1)
		{
			strcat(query," --destination-port ");
			strcat(query,PQgetvalue(res,i,4));
		}

		if (strlen(PQgetvalue(res,i,6))>0)
		{
			strcat(query," --protocol ");
			strcat(query,PQgetvalue(res,i,6));
		}
		if (strlen(PQgetvalue(res,i,5))>0)
		{
			strcat(query," --interface ");
			strcat(query,PQgetvalue(res,i,5));
		}

		printf("%s\n",query);
	}

	res=PQexec(conn,"select distinct name from chains where not type='acct'");
	for (i=0;i<PQntuples(res);i++)
	{
		snprintf(query,290,"select srcip,srcport,dstip,dstport,proto,iface,log,rule,mark,prio from %s order by prio",PQgetvalue(res,i,0));
		res1=PQexec(conn,query);
//                printf("Chain %s, rules %d \n",PQgetvalue(res,i,0),PQntuples(res1));
		for (j=0;j<PQntuples(res1);j++)
		{
			snprintf(query,290,"%s -A %s -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0),PQgetvalue(res1,j,2));


			if (strlen(PQgetvalue(res1,j,1))>0)
			{
				strcat(query," --source-port ");
				strcat(query,PQgetvalue(res1,j,1));
			}

			if (strlen(PQgetvalue(res1,j,3))>1)
			{
				strcat(query," --destination-port ");
				strcat(query,PQgetvalue(res1,j,3));
			}

			if (strlen(PQgetvalue(res1,j,4))>0)
			{
				strcat(query," --protocol ");
				strcat(query,PQgetvalue(res1,j,4));
			}
			if (strlen(PQgetvalue(res1,j,5))>0)
			{
				strcat(query," --interface ");
				strcat(query,PQgetvalue(res1,j,5));
			}

			if (strcmp(PQgetvalue(res1,j,6),"yes")==0)
			{
				strcat(query," -l");
			}
			if (strlen(PQgetvalue(res1,j,7))>0)
			{
				strcat(query," -j ");
				strcat(query,PQgetvalue(res1,j,7));
			}
			if (strlen(PQgetvalue(res1,j,8))>0)
			{
				strcat(query," --mark ");
				strcat(query,PQgetvalue(res1,j,8));
			}


			printf("%s\n",query);

		}
//                printf("%s -A %s -j RETURN\n",IPCHAINS,PQgetvalue(res,i,0));

	}



	PQfinish(conn);
	return(0);
}

